#ifndef GRAPHICFRAME_H
#define GRAPHICFRAME_H

#include <stdint.h>

#include "SDL.h"

#include <vector>
#include <string>
using namespace std;

#define GRAPHIC_PRIMITIVE 0
#define GRAPHIC_BITMAP 1

class GraphicFrame
{
 public:
  GraphicFrame ();
  ~GraphicFrame ();

  void incRefCount ();
  void decRefCount ();
  uint32_t getRefCount ();

  bool addReference (const string &, const string &, int16_t, int16_t);
  bool getReference(uint8_t, string &, string &, int16_t &, int16_t &);

  vector<string> & getGraphicPrimitiveList ();
  vector<string> & getGraphicBitmapList ();
  int getNumberOfElements ();
 private:
  uint32_t refCount;

  //1 vector of strings for all the graphic primitivives.
  //2 vector of strings for all the graphic bitmaps.
  //3 vector of x positions
  //4 vector of y positions
  //5 vector of which object to draw next.

  vector <string> primList;
  vector <string> bitmapList;
  vector <uint8_t> nextObjectToDraw;
  vector <int16_t> x;
  vector <int16_t> y;
};

#endif
