#include "GraphicTransformation.h"

GraphicTransformation::GraphicTransformation ()
{
  transformFlag = GRAPHIC_TRANSFORMATION_NONE;
  scaleW=16;
  scaleH=16;
  rotation=0;
  rotationAnchorX=0;
  rotationAnchorY=0;
}

GraphicTransformation::~GraphicTransformation ()
{
}

int16_t GraphicTransformation::getScaleWidth ()
{
  return scaleW;
}

int16_t GraphicTransformation::getScaleHeight ()
{
  return scaleH;
}

void GraphicTransformation::setScaleWidth (int16_t w)
{
  scaleW=w;
}

void GraphicTransformation::setScaleHeight (int16_t h)
{
  scaleH=h;
}

uint8_t GraphicTransformation::getRotationAngle ()
{
  return rotation;
}

void GraphicTransformation::setRotationAngle (uint8_t ang)
{
  rotation = ang;
}

uint8_t GraphicTransformation::getTransformFlag ()
{
  return transformFlag;
}

void GraphicTransformation::setTransformFlag (uint8_t flag)
{
  transformFlag = flag;
}

void GraphicTransformation::setRotationAnchor (int16_t x, int16_t y)
{
  rotationAnchorX=x;
  rotationAnchorY=y;
}

int16_t GraphicTransformation::getRotationAnchorX()
{
  return rotationAnchorX;
}

int16_t GraphicTransformation::getRotationAnchorY()
{
  return rotationAnchorY;
}

void GraphicTransformation::operator=(const GraphicTransformation &other) {
  transformFlag=other.transformFlag;
  scaleW=other.scaleW;
  scaleH=other.scaleH;
  rotation=other.rotation;
  rotationAnchorX=other.rotationAnchorX;
  rotationAnchorY=other.rotationAnchorY;
}

void GraphicTransformation::clear()
{
  transformFlag = GRAPHIC_TRANSFORMATION_NONE;
  scaleW=16;
  scaleH=16;
  rotation=0;
  rotationAnchorX=0;
  rotationAnchorY=0;
}
