#ifndef GRAPHICTRANSFORMATION_H
#define GRAPHICTRANSFORMATION_H

#include <stdint.h>

#include "SDL.h"
#include "sge.h"

#include <vector>
#include <string>
using namespace std;

#define GRAPHIC_TRANSFORMATION_NONE 0
#define GRAPHIC_TRANSFORMATION_SCALE 1
#define GRAPHIC_TRANSFORMATION_ROTATION 2

class GraphicTransformation
{
 public:
  GraphicTransformation ();
  ~GraphicTransformation ();

  int16_t getScaleWidth ();
  int16_t getScaleHeight ();
  void setScaleWidth (int16_t);
  void setScaleHeight (int16_t);

  uint8_t getRotationAngle ();
  void setRotationAngle (uint8_t);
  void setRotationAnchor (int16_t, int16_t);
  int16_t getRotationAnchorX();
  int16_t getRotationAnchorY();

  uint8_t getTransformFlag ();
  void setTransformFlag (uint8_t);

  void clear();

  void operator=(const GraphicTransformation &other);
 private:
  uint8_t transformFlag;
  int16_t scaleW, scaleH;
  uint8_t rotation;
  int16_t rotationAnchorX, rotationAnchorY;
};

#endif
