#include <stdint.h>

#include <vector>
using namespace std;

#include "LocalInput.h"
#include "Input.h"

//This child of Input captures input from the mouse, keyboard, joysticks and anything else connected to this computer. It should read a configuration file to figure out what it needs to read.

LocalInput :: LocalInput ()
{
  //initialize connection to devices here
  button1IsHelp=false;
}

LocalInput :: ~LocalInput ()
{
  //break connections with devices here
}

void LocalInput :: pollInput (SDL_Event & mainEvent, vector <Input> & commandBuffer)
{
  //stores commands onto a buffer, from external devices

  Input lit;
  lit.playerID = 0;
  lit.setInput(INPUT_NONE);

  switch (mainEvent.type)
    {
    case (SDL_KEYUP):
      break;
    case (SDL_KEYDOWN):
      if (mainEvent.key.keysym.sym == SDLK_ESCAPE)
	lit.setInput(INPUT_QUITGAME);
      break;
    case (SDL_MOUSEMOTION):
      lit.pushData(mainEvent.motion.x);
      lit.pushData(mainEvent.motion.y);

      if (mainEvent.motion.state==0||SDL_GetMouseState(NULL,NULL)==0)
	{
	  lit.pushData(MOUSE_BUTTON_NONE);
	  lit.setInput(INPUT_MOUSEMOTION);
	}
      else
	{
	  lit.setInput(INPUT_MOUSEDRAG);
	  if (SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1) && button1IsHelp ||
	      !SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1) && !button1IsHelp)
	    lit.pushData(MOUSE_BUTTON_HELP);
	  else if (SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1) && !button1IsHelp ||
		   !SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1) && button1IsHelp)
	    lit.pushData(MOUSE_BUTTON_ACTION);
	}
      break;
    case (SDL_MOUSEBUTTONUP):
      lit.setInput(INPUT_MOUSEUP);
      lit.pushData(mainEvent.motion.x);
      lit.pushData(mainEvent.motion.y);
      
      if (mainEvent.button.button == 1 && button1IsHelp ||
	  mainEvent.button.button != 1 && !button1IsHelp)
	lit.pushData(MOUSE_BUTTON_HELP);
      else if (mainEvent.button.button == 1 && !button1IsHelp ||
	       mainEvent.button.button != 1 && button1IsHelp)
	lit.pushData(MOUSE_BUTTON_ACTION);
      break;
    case (SDL_MOUSEBUTTONDOWN):
      lit.setInput(INPUT_MOUSEDOWN);
      lit.pushData(mainEvent.motion.x);
      lit.pushData(mainEvent.motion.y);

      if (mainEvent.button.button == 1 && button1IsHelp ||
	  mainEvent.button.button != 1 && !button1IsHelp)
	lit.pushData(MOUSE_BUTTON_HELP);
      else if (mainEvent.button.button == 1 && !button1IsHelp ||
	       mainEvent.button.button != 1 && button1IsHelp)
	lit.pushData(MOUSE_BUTTON_ACTION);
      break;
    };

  commandBuffer.push_back (lit);
  return;
}

bool LocalInput :: getButton1IsHelp ()
{
  return button1IsHelp;
}

void LocalInput :: setButton1IsHelp (bool a)
{
  button1IsHelp = a;
}
