#ifndef POWERSELECTOR_H
#define POWERSELECTOR_H

#include <stdint.h>
#include "SDL.h"

#include "Button.h"
#include "../util/ResourceHandler.h"

#include <vector>
using namespace std;

//The Power Selector is a panel of 10 buttons.
//9 are in a 3x3 grid with the 10th taking up the right side.
//The user is able to click on a button to highlight it and again to confirm a choice.

class PowerSelector : public Button {
 public:
  PowerSelector();
  ~PowerSelector();

  void clear();

  //access and get the selected index.
  int getSelected();
  void setSelected(int);

  //You can get the previously selected index.
  int getPreviousSelected();

  //get and set the dimensions of an individual box.
  void setIndividualBoxDimensions (uint16_t w, uint16_t h);
  uint16_t getIndividualBoxWidth ();
  uint16_t getIndividualBoxHeight ();

 private:
  int selected, previousSelected;
  uint16_t indyWid, indyHei;
};

#endif
