#ifndef PLAYERABILITY_H
#define PLAYERABILITY_H

#include <stdint.h>

#include <libxml/parser.h>
#include <libxml/tree.h>
#include <libxml/xpath.h>
#include <libxml/xpathInternals.h>

#include <vector>
using namespace std;

#include "Ability.h"

class PlayerAbility : public Ability {
 public:
  PlayerAbility ();
  ~PlayerAbility ();

  uint8_t getMinLevel (uint8_t clas);
  void setMinLevel (uint8_t clas, uint8_t lev);

  uint8_t getBuffID ();
  void setSelfBuff (bool sb);
  void setBuffID (uint8_t bid);

  bool loadPlayerAbility (const string &);
  bool loadPlayerAbilityHelper (xmlDocPtr doc, xmlXPathContextPtr xpathCtx, const string & xpath);

  uint8_t getRechargeTime();
  void setRechargeTime(uint8_t);

  const string & getDescription ();
  void setDescription (const string &);

 private:
  vector <uint8_t> minLevel;

  bool selfBuff; //if true, this attack will not harm the enemy when it hits.
  uint8_t buffID; //if it is not null, this is the buff granted when the attack hits.
  uint8_t rechargeTime;
  string description;
};
#endif
