#ifndef SDLRESOURCEGFXCOMPLEX_H
#define SDLRESOURCEGFXCOMPLEX_H

#include <stdint.h>

#include "SDL.h"
#include "GFXMod.h"
#include "SDLResourceGFX.h"

#include <libxml/parser.h>
#include <libxml/tree.h>
#include <libxml/xpath.h>
#include <libxml/xpathInternals.h>

#include <vector>
#include <string>
using namespace std;

class SDLResourceEngine;

class SDLResourceComplexGFX
{
 public:
  SDLResourceComplexGFX ();
  ~SDLResourceComplexGFX ();

  void draw (SDL_Surface * output, GFXMod * gm, SDLResourceEngine * sdlRE);

  int32_t getXPos ();
  int32_t getYPos ();

  void setXPos (int32_t);
  void setYPos (int32_t);

  bool loadComplexGFX (const string & index, SDLResourceEngine * sdlRE);
  bool loadSingleGFX (SDLResourceEngine *, xmlDocPtr, xmlXPathContextPtr, const string &);

  const string & getComplexGFXIndex ();

 private:
  void calculateDimensions ();

  vector <string> gfxs;
  vector <int32_t> posX;
  vector <int32_t> posY;

  string compGfxIndex;
  int32_t xPos, yPos;
};

#endif
