#ifndef SDLRESOURCEFRAMEBUFFER_H
#define SDLRESOURCEFRAMEBUFFER_H

#include <stdint.h>

#include "SDL.h"

#include <string>
using namespace std;

//this structure holds a buffer for an image.

class SDLResourceFrameBuffer
{
 public:
  SDLResourceFrameBuffer();
  ~SDLResourceFrameBuffer();

  bool operator==(const SDLResourceFrameBuffer &other) const;

  bool loadPic (const string & index);
  void lockPic ();
  uint8_t releasePic ();
  SDL_Surface * getPic ();

  int getWidth ();
  int getHeight ();

  const string & getPicIndex ();
  bool deletePic ();

 private:
  int w, h;
  SDL_Surface * pic;
  string picIndex;
  uint8_t refcount;
};


#endif
