#include <stdint.h>

#include "SDL.h"
#include "SDLResourceFrameSource.h"
#include "SDLResourceFrameBuffer.h"

using namespace std;

SDLResourceFrameSource :: SDLResourceFrameSource ()
{
  xPos = 0;
  yPos = 0;
  picIndex = "NULL_INDEX";
  frameBufferName = "NULL_INDEX";
}

SDLResourceFrameSource :: ~SDLResourceFrameSource()
{
}

void SDLResourceFrameSource :: recieveFrameBuffer (const string & nam)
{
  
  return;
}

void SDLResourceFrameSource :: releaseFrameBuffer ()
{
  //When finished, this source will release the buffer.

  if (sdlFB == NULL)
    return;

  sdlFB -> releasePic ();

  sdlFB = NULL;
}

void SDLResourceFrameSource :: draw (SDL_Surface * output, uint8_t orientation)
{
  //draw buffer on surface.

  //orientation uses bit masks.
  //Horizontal
  //0x1 : Put text to the right of the coordinate.
  //0x2 : Put text to the left of the coordinate.
  //Otherwise, horizontally center the text.
  //Vertical
  //0x4 : Put text Below the coordinate.
  //0x8 : Put text Above the coordinate.
  //Otherwise, vertically center the text.

  SDL_Rect dest;
 
  //dest.x = getXPos () - (sdlFB -> getWidth ()/2);
  //dest.y = getYPos () - (sdlFB -> getHeight ()/2);
  dest.w = sdlFB -> getWidth (); //pic->w;
  dest.h = sdlFB -> getHeight (); //pic->h;
  dest.x = getXPos ();
  dest.y = getYPos ();

  if (orientation & 0x1)
    dest.x += 0;
  else if (orientation & 0x2)
    dest.x -= sdlFB -> getWidth ();
  else
    dest.x -= sdlFB -> getWidth ()/ 2;
  
  if (orientation & 0x4)
    dest.y += 0;
  else if (orientation & 0x8)
    dest.y -= sdlFB -> getHeight ();
  else
    dest.y -= sdlFB -> getHeight ()/2;
 
  SDL_BlitSurface(sdlFB -> getPic (), NULL, output, &dest); //NULL means the entire source image is sent.
}

int SDLResourceFrameSource :: getWidth ()
{return sdlFB -> getWidth (); }

int SDLResourceFrameSource :: getHeight ()
{return sdlFB -> getHeight (); }

int32_t SDLResourceFrameSource :: getXPos ()
{return xPos;}

int32_t SDLResourceFrameSource :: getYPos ()
{return yPos;}

void SDLResourceFrameSource :: setXPos (int32_t x)
{xPos = x;}

void SDLResourceFrameSource :: setYPos (int32_t y)
{yPos = y;}

SDLResourceFrameBuffer * SDLResourceFrameSource :: getFrameBuffer ()
{
  return frameBufferName;
}

const string & SDLResourceFrameSource :: getPicIndex ()
{
  return picIndex;
}
