#ifndef SDLRESOURCEFRAMESOURCE_H
#define SDLRESOURCEFRAMESOURCE_H

#include <stdint.h>

#include "SDL.h"

#include "SDLResourceFrameBuffer.h"

#include <string>
using namespace std;

//this structure can refer to a frame buffer

//SDL Resource Engine is responsible for refcount.

class SDLResourceFrameSource
{
 public:
  SDLResourceFrameSource();
  ~SDLResourceFrameSource();

  uint8_t recieveFrameBuffer (const SDLResourceFrameBuffer &);
  void releaseFrameBuffer ();

  void draw (SDL_Surface * output, uint8_t orientation);

  int32_t getXPos ();
  int32_t getYPos ();

  void setXPos (int32_t);
  void setYPos (int32_t);

  int getWidth ();
  int getHeight ();

  const string & getFrameBuffer ();
  const string & getPicIndex ();
 private:
  int32_t xPos, yPos;
  string picIndex, frameBufferName;
};


#endif
