#ifndef SDLRESOURCEMUSIC_H
#define SDLRESOURCEMUSIC_H

#include <stdint.h>

#include "SDL.h"

#include <vector>
#include <string>
using namespace std;

#include "SDL_mixer.h"

//this holds one music file.

class SDLResourceMusic
{
 public:
  SDLResourceMusic ();
  ~SDLResourceMusic ();

  bool loadMusic (const string &);
  uint8_t freeMusic ();

  bool PlayMusic (int loops = 1, int ms = 0, double pos = 0.0);
  uint8_t HaltMusic (int ms = 0);

  int isPlaying ();

  uint32_t getMusicLength ();

 private:
  Mix_Music *musicChunk; //music chunk that sdl_mixer works on
  string musicIndex;
  uint32_t musicLength; //milliseconds
};

#endif
