#ifndef SDLRESOURCESOUNDSOURCE_H
#define SDLRESOURCESOUNDSOURCE_H

#include <stdint.h>

#include "SDL.h"
#include "SDL_mixer.h"

#include "SDLResourceSoundBuffer.h"

//this structure can refer to a sound buffer

class SDLResourceSoundSource
{
 public:
  SDLResourceSoundSource();
  ~SDLResourceSoundSource();

  uint8_t recieveSoundBuffer (SDLResourceSoundBuffer *);
  void releaseSoundBuffer ();

  int16_t play (uint8_t vol = MIX_MAX_VOLUME);

  uint8_t getPanPos ();
  uint8_t getVolume ();

  void setPanPos (uint8_t);
  void setVolume (uint8_t);

  SDLResourceSoundBuffer * getSoundBuffer ();
 private:
  SDLResourceSoundBuffer * sdlSB;
  int16_t soundChannel;
  uint8_t leftPan;
  uint8_t volume;
};


#endif
