#ifndef SDLRESOURCETOON_H
#define SDLRESOURCETOON_H

#include <stdint.h>

#include "SDL.h"

#include "SDLResourceAnimation.h"

#include <vector>
#include <string>
using namespace std;

/*
This is an object that houses animation and sound effects.

Top level
=========
fields:
ToonIndex
vector <animations>
currentAnimationIndex
xPos
yPos
*/

#define NULL_INDEX 0

#define ANIMATION_STATUS_PLAY 0
#define ANIMATION_STATUS_PAUSE 1
#define ANIMATION_STATUS_STOP 2

class SDLResourceEngine;

class SDLResourceToon
{
 public:

  SDLResourceToon (SDLResourceEngine *);
  ~SDLResourceToon ();

  bool loadToon (const string &);
  bool chooseAnim (uint8_t);
  void playAnim ();
  void pauseAnim ();
  void stopAnim ();
  void draw (int32_t, int32_t, bool respectCamera = true, uint8_t orientation = 0);

 private:
  void setNextFrame (uint32_t);

  vector <SDLResourceAnimation *> * anims;

  uint8_t playStatus;
  uint16_t currentFrame;
  uint32_t previousAnimTime;
  uint32_t timeInCurrentFrame;
  int16_t loopCounter;

  uint8_t currentAnim;

  SDLResourceEngine * sdlRE;
};

#endif
